Attribute VB_Name = "mdlMaster"
Option Explicit
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Const MAX_CHUNK = 8192 'Max size of sendable data
Public bReplied As Boolean 'True if server replied

Sub SendFile(Fname As String)
Dim DataChunk As String
Dim Passes As Long
SendData "OpenFile," & Fname ' send over the filename so the Server knows where to store the file.
Pause 200
Open Fname For Binary As #1
  Do While Not EOF(1)
    Passes = Passes + 1
    DataChunk = Input(MAX_CHUNK, #1) 'get some of the file data, 8192 bytes, don't go bigger
    SendData DataChunk
    frmMaster.lblStatus = "Transfering... " & (MAX_CHUNK * Passes) & " bytes"
    Pause 200
    DoEvents
  Loop
  SendData "CloseFile,"
  frmMaster.lblStatus = "Connected."
Close #1
Passes = 0
End Sub

Function GetFileName(Fname As String) As String
Dim I As Integer
Dim TempStr As String
For I = 1 To Len(Fname)
  TempStr = Right(Fname, I)
  If Left(TempStr, 1) = "\" Then
    GetFileName = Mid(TempStr, 2, Len(TempStr))
    Exit Function
  End If
Next I
End Function

Function SendData(sData As String) As Boolean
Dim TimeOut As Long
On Error GoTo ErrH
bReplied = False
frmMaster.tcpClient.SendData sData
Do Until (frmMaster.tcpClient.State = 0) Or (TimeOut < 100000)
  DoEvents
  TimeOut = TimeOut + 1
  If TimeOut > 100000 Then Exit Do
Loop
SendData = True
Exit Function
    
ErrH:
    SendData = False
    MsgBox Err.Description, 16, "Error #" & Err.Number
    frmMaster.lblStatus = "Disconnected."
End Function

Sub Pause(HowLong As Long)
Dim Tick As Long
Tick = GetTickCount()
Do
  DoEvents
Loop Until Tick + HowLong < GetTickCount
End Sub
