VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmSlave 
   BackColor       =   &H00C0FFFF&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Transfering Files with Winsock"
   ClientHeight    =   2010
   ClientLeft      =   30
   ClientTop       =   330
   ClientWidth     =   5610
   BeginProperty Font 
      Name            =   "Times New Roman"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2010
   ScaleWidth      =   5610
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog cdOpen 
      Left            =   3600
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton cmdSend 
      BackColor       =   &H00C0FFFF&
      Caption         =   "Send"
      Height          =   375
      Left            =   2160
      Style           =   1  'Graphical
      TabIndex        =   5
      Top             =   600
      Width           =   972
   End
   Begin VB.CommandButton cmdBrowse 
      BackColor       =   &H00C0FFFF&
      Caption         =   "Browse"
      Height          =   375
      Left            =   1080
      Style           =   1  'Graphical
      TabIndex        =   4
      Top             =   600
      Width           =   972
   End
   Begin VB.TextBox txtFileName 
      BackColor       =   &H00C0FFFF&
      Height          =   300
      Left            =   1080
      TabIndex        =   2
      Top             =   120
      Width           =   4455
   End
   Begin MSWinsockLib.Winsock tcpServer 
      Left            =   4200
      Top             =   480
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.CommandButton cmdEnd 
      BackColor       =   &H00C0FFFF&
      Cancel          =   -1  'True
      Caption         =   "End"
      Height          =   375
      Left            =   4560
      Style           =   1  'Graphical
      TabIndex        =   0
      Top             =   1200
      Width           =   972
   End
   Begin VB.Label lblProgram 
      BackStyle       =   0  'Transparent
      Caption         =   "Program by Joost Tack"
      ForeColor       =   &H000040C0&
      Height          =   255
      Left            =   3840
      TabIndex        =   6
      Top             =   1680
      Width           =   1695
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "File to send:"
      ForeColor       =   &H000000FF&
      Height          =   204
      Index           =   0
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   840
   End
   Begin VB.Label lblStatus 
      BackColor       =   &H00C0FFFF&
      BorderStyle     =   1  'Fixed Single
      Caption         =   " Status : Listening......."
      Height          =   375
      Left            =   1080
      TabIndex        =   1
      Top             =   1200
      Width           =   3375
   End
End
Attribute VB_Name = "frmSlave"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Program by Joost Tack
'Email: (joosttack@hotmail.com)
'Website: http://users.pandora.be/joske

Option Explicit

Private Sub cmdEnd_Click()
Unload Me
End Sub

Private Sub cmdSend_Click()
Dim FName_Only As String
If txtFileName = "" Then
  MsgBox "No file selected to send...", vbCritical
Else
  If tcpServer.State <> sckClosed Then
    FName_Only = GetFileName(txtFileName)
    SendFile FName_Only
  End If
End If
End Sub

Private Sub Form_Load()
With tcpServer
  .LocalPort = 600
  .RemotePort = 610
  .Listen
End With
bInConnection = False
lblStatus = "Listening.... (Not Connected)"
End Sub

Private Sub Form_Unload(Cancel As Integer)
SendData "ServerClosed,"
Pause 500
tcpServer.Close
End
End Sub

Private Sub tcpServer_Close()
If tcpServer.State <> sckClosed Then tcpServer.Close
Form_Load 'resume listening
End Sub

Private Sub tcpServer_ConnectionRequest(ByVal requestID As Long)
On Error GoTo IDERROR
If tcpServer.State <> sckClosed Then tcpServer.Close
tcpServer.Accept requestID    'Make the connection
bInConnection = True
lblStatus = "Listening... Connected."
SendData "Accepted,"
Exit Sub
     
IDERROR:
  MsgBox Err.Description, vbCritical
End Sub

Private Sub tcpServer_DataArrival(ByVal bytesTotal As Long)
Dim Command As String, NewArrival As String, Data As String
Static DataCnt As Long
Dim I As Integer
tcpServer.GetData NewArrival, vbString
If Len(NewArrival) < MAX_CHUNK Then
  For I = 0 To Len(NewArrival)
    If Mid(NewArrival$, I + 1, 1) = "," Then
      Command = Left(NewArrival, I)
      Data$ = Right(NewArrival, Len(NewArrival) - (I + 1))
      Exit For
    End If
  Next
End If
Select Case Command$
  Case "OpenFile"
    Dim Fname As String
    Fname$ = App.Path & "\" & Data$
    Open Fname$ For Binary As #1
    lblStatus = "File opened.... " & Data$
  Case "CloseFile"
     Close #1
     lblStatus = "File Transfer complete..."
     Pause 1000
     lblStatus = "Listening... (Connected)"
     DataCnt = 0
  Case Else 'only data
      Put #1, , NewArrival
      DataCnt = DataCnt + 1
      lblStatus = "Recieving Data... " & MAX_CHUNK * DataCnt & " Bytes"
End Select
End Sub

Private Sub cmdBrowse_Click()
cdOpen.ShowOpen
If vbOK Then txtFileName = cdOpen.FileName
End Sub
